/**
 * Annotation functions
 */
'use strict';

/**
 * Creates a annotation element.
 */
function createAnnotationElement(annoPath, roomId, annoId, titleTextSwe, titleTextEng, titleTextDan, titleTextGer, bodyTextSwe, bodyTextEng, bodyTextDan, bodyTextGer, ccbyText1, ccbyText2, ccbyText3, extraImage1Tag, extraImage2Tag, extraImage3Tag) {
  var html =
    '<div class="post AnnoCard AnnoRoom-' + roomId + ' anno-' + roomId + '-' + annoId + ' mdl-cell mdl-cell--4-col-phone ' +
    '      mdl-cell--8-col-tablet mdl-cell--12-col-desktop mdl-grid mdl-grid--no-spacing" style="display: flex;">' +
    '  <div class="mdl-card mdl-shadow--2dp" style="width: 100%;">' +
    '    <div class="mdl-card__title mdl-color--light-blue-600 mdl-color-text--white">' +
    '      <h4 class="mdl-card__title-text"></h4>' +
    '    </div>' +
    '    <div class="mdl-card__supporting-text mdl-color-text--grey-600" style="width: auto; display: block;">' +
    '      <form class="anno-form" id="anno-form-' + annoId + '" action="#" >' +
    '        <div class="mdl-grid" style="padding: 0px;">' +
    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="titleTextSwe mdl-textfield__input" type="text" id="titleTextSwe-' + annoId + '">' +
    '            <label class="mdl-textfield__label" for="titleTextSwe-' + annoId + '">Swedish Annotation title</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="titleTextEng mdl-textfield__input" type="text" id="titleTextEng-' + annoId + '">' +
    '            <label class="mdl-textfield__label" for="titleTextEng-' + annoId + '">English Annotation title</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="titleTextDan mdl-textfield__input" type="text" id="titleTextDan-' + annoId + '">' +
    '            <label class="mdl-textfield__label" for="titleTextDan-' + annoId + '">Danish Annotation title</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="titleTextGer mdl-textfield__input" type="text" id="titleTextGer-' + annoId + '">' +
    '            <label class="mdl-textfield__label" for="titleTextGer-' + annoId + '">German Annotation title</label>' +
    '          </div>' +
    '        </div>' +

    '        <div class="mdl-grid" style="padding: 0px;">' +
    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <textarea class="bodyTextSwe mdl-textfield__input" rows="4" id="bodyTextSwe-' + annoId + '"></textarea>' +
    '            <label class="mdl-textfield__label" for="bodyTextSwe-' + annoId + '">Swedish Annotation bodytext</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <textarea class="bodyTextEng mdl-textfield__input" rows="4" id="bodyTextEng-' + annoId + '"></textarea>' +
    '            <label class="mdl-textfield__label" for="bodyTextEng-' + annoId + '">English Annotation bodytext</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <textarea class="bodyTextDan mdl-textfield__input" rows="4" id="bodyTextDan-' + annoId + '"></textarea>' +
    '            <label class="mdl-textfield__label" for="bodyTextDan-' + annoId + '">Danish Annotation bodytext</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <textarea class="bodyTextGer mdl-textfield__input" rows="4" id="bodyTextGer-' + annoId + '"></textarea>' +
    '            <label class="mdl-textfield__label" for="bodyTextGer-' + annoId + '">German Annotation bodytext</label>' +
    '          </div>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
    '          <input class="extraImage1Tag mdl-textfield__input" type="text" id="extraImage1Tag-' + annoId + '">' +
    '          <label class="mdl-textfield__label" for="extraImage1Tag-' + annoId + '">ExtraImage1Tag</label>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label" style="display: none;">' +
    '          <input class="ccbyText1 mdl-textfield__input" type="text" id="ccbyText1-' + annoId + '">' +
    '          <label class="mdl-textfield__label" for="ccbyText1-' + annoId + '">ccbyText1</label>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
    '          <input class="extraImage2Tag mdl-textfield__input" type="text" id="extraImage2Tag-' + annoId + '">' +
    '          <label class="mdl-textfield__label" for="extraImage2Tag-' + annoId + '">ExtraImage2Tag</label>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label" style="display: none;">' +
    '          <input class="ccbyText2 mdl-textfield__input" type="text" id="ccbyText2-' + annoId + '">' +
    '          <label class="mdl-textfield__label" for="ccbyText2-' + annoId + '">ccbyText2</label>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
    '          <input class="extraImage3Tag mdl-textfield__input" type="text" id="extraImage3Tag-' + annoId + '">' +
    '          <label class="mdl-textfield__label" for="extraImage3Tag-' + annoId + '">ExtraImage3Tag</label>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label" style="display: none;">' +
    '          <input class="ccbyText3 mdl-textfield__input" type="text" id="ccbyText3-' + annoId + '">' +
    '          <label class="mdl-textfield__label" for="ccbyText3-' + annoId + '">ccbyText3</label>' +
    '        </div>' +

    '        <button type="submit" class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect">Update</button>' +
    '      </form>' +
    '    </div>' +
    '  </div>' +
    '</div>';

  // Create the DOM element from the HTML.
  var div = document.createElement('div');
  div.innerHTML = html;
  var annoElement = div.firstChild;

  var cardTitle = annoElement.getElementsByClassName('mdl-card__title')[0];
  var cardSupportingText = annoElement.getElementsByClassName('mdl-card__supporting-text')[0];

  var annoUpdateForm = annoElement.getElementsByClassName('anno-form')[0];
  var titleTextSweInput = annoElement.getElementsByClassName('titleTextSwe')[0];
  var titleTextEngInput = annoElement.getElementsByClassName('titleTextEng')[0];
  var titleTextDanInput = annoElement.getElementsByClassName('titleTextDan')[0];
  var titleTextGerInput = annoElement.getElementsByClassName('titleTextGer')[0];
  var bodyTextSweInput = annoElement.getElementsByClassName('bodyTextSwe')[0];
  var bodyTextEngInput = annoElement.getElementsByClassName('bodyTextEng')[0];
  var bodyTextDanInput = annoElement.getElementsByClassName('bodyTextDan')[0];
  var bodyTextGerInput = annoElement.getElementsByClassName('bodyTextGer')[0];
  var extraImage1TagInput = annoElement.getElementsByClassName('extraImage1Tag')[0];
  var ccbyText1Input = annoElement.getElementsByClassName('ccbyText1')[0];
  var extraImage2TagInput = annoElement.getElementsByClassName('extraImage2Tag')[0];
  var ccbyText2Input = annoElement.getElementsByClassName('ccbyText2')[0];
  var extraImage3TagInput = annoElement.getElementsByClassName('extraImage3Tag')[0];
  var ccbyText3Input = annoElement.getElementsByClassName('ccbyText3')[0];

  // Set values.   
  annoElement.getElementsByClassName('mdl-card__title-text')[0].innerText = roomId + "\n" + annoId;
  annoElement.getElementsByClassName('titleTextSwe')[0].value = titleTextSwe;
  annoElement.getElementsByClassName('titleTextEng')[0].value = titleTextEng;
  annoElement.getElementsByClassName('titleTextDan')[0].value = titleTextDan;
  annoElement.getElementsByClassName('titleTextGer')[0].value = titleTextGer;
  annoElement.getElementsByClassName('bodyTextSwe')[0].value = bodyTextSwe;
  annoElement.getElementsByClassName('bodyTextEng')[0].value = bodyTextEng;
  annoElement.getElementsByClassName('bodyTextDan')[0].value = bodyTextDan;
  annoElement.getElementsByClassName('bodyTextGer')[0].value = bodyTextGer;
  annoElement.getElementsByClassName('extraImage1Tag')[0].value = extraImage1Tag;
  annoElement.getElementsByClassName('ccbyText1')[0].value = ccbyText1;
  annoElement.getElementsByClassName('extraImage2Tag')[0].value = extraImage2Tag;
  annoElement.getElementsByClassName('ccbyText2')[0].value = ccbyText2;
  annoElement.getElementsByClassName('extraImage3Tag')[0].value = extraImage3Tag;
  annoElement.getElementsByClassName('ccbyText3')[0].value = ccbyText3;

  if (componentHandler) {
    componentHandler.upgradeElements(annoElement.getElementsByClassName('mdl-textfield'));
  }

  // Update Annotation data
  annoUpdateForm.onsubmit = function (e) {
    e.preventDefault();
    updateAnnotationData(annoPath, roomId, annoId, titleTextSweInput.value, titleTextEngInput.value, titleTextDanInput.value, titleTextGerInput.value, bodyTextSweInput.value, bodyTextEngInput.value, bodyTextDanInput.value, bodyTextGerInput.value, ccbyText1Input.value, ccbyText2Input.value, ccbyText3Input.value, extraImage1TagInput.value, extraImage2TagInput.value, extraImage3TagInput.value);
  };

  cardTitle.addEventListener('click', function () {
    if (cardSupportingText.style.display == 'none') {
      cardSupportingText.style.display = 'block';
    } else {
      cardSupportingText.style.display = 'none';
    }

  });

  return annoElement;
}

/**
 * Updates annotation data on the Firebase DB.
 */
function updateAnnotationData(annoPath, roomId, annoId, titleTextSwe, titleTextEng, titleTextDan, titleTextGer, bodyTextSwe, bodyTextEng, bodyTextDan, bodyTextGer, ccbyText1, ccbyText2, ccbyText3, extraImage1Tag, extraImage2Tag, extraImage3Tag) {

  var annotationData = {
    titleTextSwe: titleTextSwe,
    titleTextEng: titleTextEng,
    titleTextDan: titleTextDan,
    titleTextGer: titleTextGer,
    bodyTextSwe: bodyTextSwe,
    bodyTextEng: bodyTextEng,
    bodyTextDan: bodyTextDan,
    bodyTextGer: bodyTextGer,
    ccbyText1: ccbyText1,
    ccbyText2: ccbyText2,
    ccbyText3: ccbyText3,
    extraImage1Tag: extraImage1Tag,
    extraImage2Tag: extraImage2Tag,
    extraImage3Tag: extraImage3Tag
  };
  var updates = {};
  updates['/Annoteringsdata/' + annoPath + '/' + roomId + '/' + annoId] = annotationData;

  return firebase.database().ref().update(updates);
}


/**
 * Creates a annotation-room radio element.
 */
function createRoomRadioElement(roomId) {
  var html =
    '<label class="mdl-radio mdl-js-radio mdl-js-ripple-effect" for="radio-' + roomId + '">' +
    '  <input type="radio" id="radio-' + roomId + '" class="mdl-radio__button" ' +
    '                   onclick="onRoomRadioClick(this)"  name="roomRadios" value="' + roomId + '">' +
    '  <span class="mdl-radio__label">' + roomId + '</span>' +
    '</label>';

  // Create the DOM element from the HTML.
  var div = document.createElement('div');
  div.innerHTML = html;
  var radioElement = div.firstChild;

  if (componentHandler) {
    componentHandler.upgradeElements(radioElement);
  }


  return radioElement;
}


var annosAllContainer = document.getElementById('annotations-list').getElementsByClassName('annos-container')[0];
/**
 * On Room Radio button click
 */
function onRoomRadioClick(radioInput) {
  var annoCards = annosAllContainer.getElementsByClassName('AnnoCard');
  for (let element of annoCards) {
    element.style.display = 'none';
  }

  var currentRoomAnnoCards = annosAllContainer.getElementsByClassName('AnnoRoom-' + radioInput.value);

  for (let element of currentRoomAnnoCards) {
    element.style.display = 'flex';
  }


}
