/**
 * Annotation functions
 */
'use strict';

/**
 * Creates a annotation element.
 */
function createAnnotationElement(langAnnoPath, roomId, annoId, titleText, bodyText, ccbyText1, ccbyText2, ccbyText3, borderTopImageTag, extraImage1Tag, extraImage2Tag, extraImage3Tag, borderBottomImageTag) {  
  var html =
        '<div class="post anno-' + roomId + '-' + annoId + ' mdl-cell mdl-cell--4-col-phone ' +
                    'mdl-cell--4-col-tablet mdl-cell--4-col-desktop mdl-grid mdl-grid--no-spacing">' +
          '<div class="mdl-card mdl-shadow--2dp" style="width: 468px;">' +
            '<div class="mdl-card__title mdl-color--light-blue-600 mdl-color-text--white">' +
              '<h4 class="mdl-card__title-text"></h4>' +
            '</div>' +
            '<div class="mdl-card__supporting-text mdl-color-text--grey-600">' +
              '<form class="anno-form" id="anno-form-' + annoId + '" action="#" >' +
      
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<input class="titleText mdl-textfield__input" type="text" id="titleText-' + annoId + '">' +
                  '<label class="mdl-textfield__label" for="titleText-' + annoId + '">Annotation title</label>' +
                '</div>' +
                
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<input class="borderTopImageTag mdl-textfield__input" type="text" id="borderTopImageTag-' + annoId + '">' +
                  '<label class="mdl-textfield__label" for="borderTopImageTag-' + annoId + '">BorderTopImageTag</label>' +
                '</div>' +
                
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<textarea class="bodyText mdl-textfield__input" rows="4" id="bodyText-' + annoId + '"></textarea>' +
                  '<label class="mdl-textfield__label" for="bodyText-' + annoId + '">Annotation bodytext</label>' +
                '</div>' +
                
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<input class="extraImage1Tag mdl-textfield__input" type="text" id="extraImage1Tag-' + annoId + '">' +
                  '<label class="mdl-textfield__label" for="extraImage1Tag-' + annoId + '">ExtraImage1Tag</label>' +
                '</div>' +
                
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<input class="ccbyText1 mdl-textfield__input" type="text" id="ccbyText1-' + annoId + '">' +
                  '<label class="mdl-textfield__label" for="ccbyText1-' + annoId + '">ccbyText1</label>' +
                '</div>' +
                
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<input class="extraImage2Tag mdl-textfield__input" type="text" id="extraImage2Tag-' + annoId + '">' +
                  '<label class="mdl-textfield__label" for="extraImage2Tag-' + annoId + '">ExtraImage2Tag</label>' +
                '</div>' +
              
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<input class="ccbyText2 mdl-textfield__input" type="text" id="ccbyText2-' + annoId + '">' +
                  '<label class="mdl-textfield__label" for="ccbyText2-' + annoId + '">ccbyText2</label>' +
                '</div>' +
                    
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<input class="extraImage3Tag mdl-textfield__input" type="text" id="extraImage3Tag-' + annoId + '">' +
                  '<label class="mdl-textfield__label" for="extraImage3Tag-' + annoId + '">ExtraImage3Tag</label>' +
                '</div>' +
              
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<input class="ccbyText3 mdl-textfield__input" type="text" id="ccbyText3-' + annoId + '">' +
                  '<label class="mdl-textfield__label" for="ccbyText3-' + annoId + '">ccbyText3</label>' +
                '</div>' +
                
                '<div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
                  '<input class="borderBottomImageTag mdl-textfield__input" type="text" id="borderBottomImageTag-' + annoId + '">' +
                  '<label class="mdl-textfield__label" for="borderBottomImageTag-' + annoId + '">BorderBottomImageTag</label>' +
                '</div>' +
      
                '<button type="submit" class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect">' +
                  'Update'+
                '</button>'+
              '</form>'+
            '</div>'+
          '</div>' +
        '</div>';
  
  // Create the DOM element from the HTML.
  var div = document.createElement('div');
  div.innerHTML = html;
  var annoElement = div.firstChild;

  var annoUpdateForm = annoElement.getElementsByClassName('anno-form')[0];
  var titleTextInput = annoElement.getElementsByClassName('titleText')[0];
  var borderTopImageTagInput = annoElement.getElementsByClassName('borderTopImageTag')[0];
  var bodyTextInput = annoElement.getElementsByClassName('bodyText')[0];
  var extraImage1TagInput = annoElement.getElementsByClassName('extraImage1Tag')[0];
  var ccbyText1Input = annoElement.getElementsByClassName('ccbyText1')[0];
  var extraImage2TagInput = annoElement.getElementsByClassName('extraImage2Tag')[0];
  var ccbyText2Input = annoElement.getElementsByClassName('ccbyText2')[0];
  var extraImage3TagInput = annoElement.getElementsByClassName('extraImage3Tag')[0];
  var ccbyText3Input = annoElement.getElementsByClassName('ccbyText3')[0];
  var borderBottomImageTagInput = annoElement.getElementsByClassName('borderBottomImageTag')[0];

  // Set values.   
  annoElement.getElementsByClassName('mdl-card__title-text')[0].innerText = roomId + "\n" + annoId;
  annoElement.getElementsByClassName('titleText')[0].value = titleText;
  annoElement.getElementsByClassName('borderTopImageTag')[0].value = borderTopImageTag;
  annoElement.getElementsByClassName('bodyText')[0].value = bodyText;
  annoElement.getElementsByClassName('extraImage1Tag')[0].value = extraImage1Tag;
  annoElement.getElementsByClassName('ccbyText1')[0].value = ccbyText1;
  annoElement.getElementsByClassName('extraImage2Tag')[0].value = extraImage2Tag;
  annoElement.getElementsByClassName('ccbyText2')[0].value = ccbyText2;
  annoElement.getElementsByClassName('extraImage3Tag')[0].value = extraImage3Tag;
  annoElement.getElementsByClassName('ccbyText3')[0].value = ccbyText3;
  annoElement.getElementsByClassName('borderBottomImageTag')[0].value = borderBottomImageTag;

  if (componentHandler) {
    componentHandler.upgradeElements(annoElement.getElementsByClassName('mdl-textfield'));
  }

  // Update Annotation data
  annoUpdateForm.onsubmit = function (e) {
    e.preventDefault();
    updateAnnotationData(langAnnoPath, roomId, annoId, titleTextInput.value, bodyTextInput.value, ccbyText1Input.value, ccbyText2Input.value, ccbyText3Input.value, borderTopImageTagInput.value, extraImage1TagInput.value, extraImage2TagInput.value, extraImage3TagInput.value, borderBottomImageTagInput.value);
  };

  return annoElement;
}

/**
 * Updates annotation data on the Firebase DB.
 */
function updateAnnotationData(langAnnoPath, roomId, annoId, titleText, bodyText, ccbyText1, ccbyText2, ccbyText3, borderTopImageTag, extraImage1Tag, extraImage2Tag, extraImage3Tag, borderBottomImageTag) {

  var annotationData = {
    titleText: titleText,
    bodyText: bodyText,
    ccbyText1: ccbyText1,
    ccbyText2: ccbyText2,
    ccbyText3: ccbyText3,
    borderTopImageTag: borderTopImageTag,
    extraImage1Tag: extraImage1Tag,
    extraImage2Tag: extraImage2Tag,
    extraImage3Tag: extraImage3Tag,
    borderBottomImageTag: borderBottomImageTag
  };
  var updates = {};
  updates['/Annoteringsdata/' + langAnnoPath + '/' + roomId + '/' + annoId] = annotationData;

  return firebase.database().ref().update(updates);
}
