/**
 * ImageTag Link functions
 */
'use strict';

/**
 * Creates a ImageTag Link element.
 */
function createImageTagLinkElement(imageTagId, link) {
    var html =
        '<div class="imagetag-link-' + imageTagId + ' mdl-shadow--2dp mdl-cell mdl-cell--12-col mdl-grid" style="background-color: white; padding: 0; margin: 0;">' +
        '  <form class="imagetag-form mdl-cell mdl-cell--12-col mdl-grid" id="imagetag-form-' + imageTagId + '" action="#" style="padding: 0; margin: 0;">' +
        '    <div class="mdl-cell mdl-cell--2-col mdl-cell--8-col-tablet mdl-cell--4-col-phone">' +
        '      <h6>' + imageTagId + ': </h6>' +
        '    </div>' +
        '    <div class="mdl-cell mdl-cell--8-col mdl-cell--8-col-tablet mdl-cell--4-col-phone">' +
        '      <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
        '        <input class="link-input mdl-textfield__input" type="text" id="link-' + imageTagId + '">' +
        '        <label class="mdl-textfield__label" for="link-' + imageTagId + '">Link</label>' +
        '      </div>' +
        '    </div>' +
        '    <div class="mdl-cell mdl-cell--2-col mdl-cell--8-col-tablet mdl-cell--4-col-phone" style="padding: 10px 0 0 30px;">' +
        '      <button type="submit" class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect">Update</button>' +
        '    </div>' +
        '  </form>' +
        '</div>';

    // Create the DOM element from the HTML.
    var div = document.createElement('div');
    div.innerHTML = html;
    var imageTagLinkElement = div.firstChild;

    var imageTagForm = imageTagLinkElement.getElementsByClassName('imagetag-form')[0];
    var linkInput = imageTagLinkElement.getElementsByClassName('link-input')[0];

    // Set values.   
    imageTagLinkElement.getElementsByClassName('link-input')[0].value = link;

    if (componentHandler) {
        componentHandler.upgradeElements(imageTagLinkElement.getElementsByClassName('mdl-textfield'));
    }

    // Update ImageTag Link data
    imageTagForm.onsubmit = function (e) {
        e.preventDefault();
        updateImageTagLinkData(imageTagId, linkInput.value);
    };

    return imageTagLinkElement;
}

/**
 * Updates imagetag link data on the Firebase DB.
 */
function updateImageTagLinkData(imageTagId, link) {

    var updates = {};
    updates['/ImageTagLinks/' + imageTagId] = link;

    return firebase.database().ref().update(updates);
}
