/**
 * Copyright 2015 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
'use strict';

// Shortcuts to DOM Elements.
var signInButton = document.getElementById('sign-in-button');
var signInButtonMicrosoft = document.getElementById('sign-in-button-microsoft');
var signOutButton = document.getElementById('sign-out-button');
var splashPage = document.getElementById('page-splash');

var topAvatarPicture = document.getElementById('topAvatar');
var topUserName = document.getElementById('topUserName');

var annotationsSection = document.getElementById('annotations-list');
var annotationsButton = document.getElementById('menu-annotations');

var annotationRadios = document.getElementById('annotation-radio-buttons');

// var swedishAnnotationsSection = document.getElementById('swedish-annotations-list');
// var swedishAnnotationsButton = document.getElementById('menu-swedish-annotations');

// var englishAnnotationsSection = document.getElementById('english-annotations-list');
// var englishAnnotationsButton = document.getElementById('menu-english-annotations');

// var danishAnnotationsSection = document.getElementById('danish-annotations-list');
// var danishAnnotationsButton = document.getElementById('menu-danish-annotations')

// var germanAnnotationsSection = document.getElementById('german-annotations-list');
// var germanAnnotationsButton = document.getElementById('menu-german-annotations');

var imageTagLinksSection = document.getElementById('imagetag-links-list');
var imageTagLinksButton = document.getElementById('menu-imagetag-links');

var guidesSection = document.getElementById('gudies-list');
var guidesButton = document.getElementById('menu-guides');

var generalTextsSection = document.getElementById('general-texts-list');
var generalTextsButton = document.getElementById('menu-general-texts');

var listeningFirebaseRefs = [];

/**
 * Starts listening for new data and populates data lists.
 */
function startDatabaseQueries() {
  startDatabaseQueriesAnnotations();
  startDatabaseQueriesImageTagLinks();
  startDatabaseQueriesGuides();
  startDatabaseQueriesGeneralTexts();
}

function startDatabaseQueriesAnnotations() {
  var annotationPath = 'Annoteringar-Alla';
  var annotationRef = firebase.database().ref('Annoteringsdata/' + annotationPath);

  // var sweAnnotationPath = 'Annoteringar-Svenska';
  // var sweAnnotationRef = firebase.database().ref('Annoteringsdata/' + sweAnnotationPath);

  // var engAnnotationPath = 'Annoteringar-Engelska';
  // var engAnnotationRef = firebase.database().ref('Annoteringsdata/' + engAnnotationPath);

  // var danAnnotationPath = 'Annoteringar-Danska';
  // var danAnnotationRef = firebase.database().ref('Annoteringsdata/' + danAnnotationPath);

  // var gerAnnotationPath = 'Annoteringar-Tyska';
  // var gerAnnotationRef = firebase.database().ref('Annoteringsdata/' + gerAnnotationPath);

  // var fetchAnnotations = function (AnnotationRef, sectionElement, langAnnoPath) {

  //   AnnotationRef.once('value').then((snapshot) => {
  //     if (snapshot.val()) {
  //       snapshot.forEach((roomSnapshot) => {
  //         var roomKey = roomSnapshot.key;
  //         var roomRef = firebase.database().ref('Annoteringsdata/' + langAnnoPath + "/" + roomKey);
  //         roomRef.on('child_added', function (annoData) {
  //           var titleText = (annoData.val() && annoData.val().titleText) || '';
  //           var bodyText = (annoData.val() && annoData.val().bodyText) || '';
  //           var ccbyText1 = (annoData.val() && annoData.val().ccbyText1) || '';
  //           var ccbyText2 = (annoData.val() && annoData.val().ccbyText2) || '';
  //           var ccbyText3 = (annoData.val() && annoData.val().ccbyText3) || '';
  //           var borderTopImageTag = (annoData.val() && annoData.val().borderTopImageTag) || '';
  //           var extraImage1Tag = (annoData.val() && annoData.val().extraImage1Tag) || '';
  //           var extraImage2Tag = (annoData.val() && annoData.val().extraImage2Tag) || '';
  //           var extraImage3Tag = (annoData.val() && annoData.val().extraImage3Tag) || '';
  //           var borderBottomImageTag = (annoData.val() && annoData.val().borderBottomImageTag) || '';
  //           var containerElement = sectionElement.getElementsByClassName('annos-container')[0];
  //           containerElement.appendChild(
  //             createAnnotationElement(langAnnoPath, roomKey, annoData.key, titleText, bodyText, ccbyText1, ccbyText2, ccbyText3, borderTopImageTag, extraImage1Tag, extraImage2Tag, extraImage3Tag, borderBottomImageTag)
  //           );
  //         });
  //         roomRef.on('child_changed', function (annoData) {
  //           var containerElement = sectionElement.getElementsByClassName('annos-container')[0];
  //           var annoElement = containerElement.getElementsByClassName('anno-' + roomKey + '-' + annoData.key)[0];
  //           annoElement.getElementsByClassName('titleText')[0].value = (annoData.val() && annoData.val().titleText) || '';
  //           annoElement.getElementsByClassName('titleText')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //           annoElement.getElementsByClassName('borderTopImageTag')[0].value = (annoData.val() && annoData.val().borderTopImageTag) || '';
  //           annoElement.getElementsByClassName('borderTopImageTag')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //           annoElement.getElementsByClassName('bodyText')[0].value = (annoData.val() && annoData.val().bodyText) || '';
  //           annoElement.getElementsByClassName('bodyText')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //           annoElement.getElementsByClassName('extraImage1Tag')[0].value = (annoData.val() && annoData.val().extraImage1Tag) || '';
  //           annoElement.getElementsByClassName('extraImage1Tag')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //           annoElement.getElementsByClassName('ccbyText1')[0].value = (annoData.val() && annoData.val().ccbyText1) || '';
  //           annoElement.getElementsByClassName('ccbyText1')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //           annoElement.getElementsByClassName('extraImage2Tag')[0].value = (annoData.val() && annoData.val().extraImage2Tag) || '';
  //           annoElement.getElementsByClassName('extraImage2Tag')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //           annoElement.getElementsByClassName('ccbyText2')[0].value = (annoData.val() && annoData.val().ccbyText2) || '';
  //           annoElement.getElementsByClassName('ccbyText2')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //           annoElement.getElementsByClassName('extraImage3Tag')[0].value = (annoData.val() && annoData.val().extraImage3Tag) || '';
  //           annoElement.getElementsByClassName('extraImage3Tag')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //           annoElement.getElementsByClassName('ccbyText3')[0].value = (annoData.val() && annoData.val().ccbyText3) || '';
  //           annoElement.getElementsByClassName('ccbyText3')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //           annoElement.getElementsByClassName('borderBottomImageTag')[0].value = (annoData.val() && annoData.val().borderBottomImageTag) || '';
  //           annoElement.getElementsByClassName('borderBottomImageTag')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  //         });
  //         roomRef.on('child_removed', function (annoData) {
  //           var containerElement = sectionElement.getElementsByClassName('annos-container')[0];
  //           var anno = containerElement.getElementsByClassName('anno-' + roomKey + '-' + annoData.key)[0];
  //           anno.parentElement.removeChild(anno);
  //         });

  //         listeningFirebaseRefs.push(roomRef);
  //       });
  //     }
  //   });
  // };

  annotationRef.once('value').then((snapshot) => {
    if (snapshot.val()) {
      snapshot.forEach((roomSnapshot) => {
        var roomKey = roomSnapshot.key;

        annotationRadios.appendChild(
          createRoomRadioElement(roomKey)
        );

        var roomRef = firebase.database().ref('Annoteringsdata/' + annotationPath + "/" + roomKey);
        roomRef.on('child_added', function (annoData) {
          var titleTextSwe = (annoData.val() && annoData.val().titleTextSwe) || '';
          var titleTextEng = (annoData.val() && annoData.val().titleTextEng) || '';
          var titleTextDan = (annoData.val() && annoData.val().titleTextDan) || '';
          var titleTextGer = (annoData.val() && annoData.val().titleTextGer) || '';
          var bodyTextSwe = (annoData.val() && annoData.val().bodyTextSwe) || '';
          var bodyTextEng = (annoData.val() && annoData.val().bodyTextEng) || '';
          var bodyTextDan = (annoData.val() && annoData.val().bodyTextDan) || '';
          var bodyTextGer = (annoData.val() && annoData.val().bodyTextGer) || '';
          var ccbyText1 = (annoData.val() && annoData.val().ccbyText1) || '';
          var ccbyText2 = (annoData.val() && annoData.val().ccbyText2) || '';
          var ccbyText3 = (annoData.val() && annoData.val().ccbyText3) || '';
          var extraImage1Tag = (annoData.val() && annoData.val().extraImage1Tag) || '';
          var extraImage2Tag = (annoData.val() && annoData.val().extraImage2Tag) || '';
          var extraImage3Tag = (annoData.val() && annoData.val().extraImage3Tag) || '';
          var containerElement = annotationsSection.getElementsByClassName('annos-container')[0];
          containerElement.appendChild(
            createAnnotationElement(annotationPath, roomKey, annoData.key, titleTextSwe, titleTextEng, titleTextDan, titleTextGer, bodyTextSwe, bodyTextEng, bodyTextDan, bodyTextGer, ccbyText1, ccbyText2, ccbyText3, extraImage1Tag, extraImage2Tag, extraImage3Tag)
          );
        });
        roomRef.on('child_changed', function (annoData) {
          var containerElement = annotationsSection.getElementsByClassName('annos-container')[0];
          var annoElement = containerElement.getElementsByClassName('anno-' + roomKey + '-' + annoData.key)[0];
          annoElement.getElementsByClassName('titleTextSwe')[0].value = (annoData.val() && annoData.val().titleTextSwe) || '';
          annoElement.getElementsByClassName('titleTextSwe')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('titleTextEng')[0].value = (annoData.val() && annoData.val().titleTextEng) || '';
          annoElement.getElementsByClassName('titleTextEng')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('titleTextDan')[0].value = (annoData.val() && annoData.val().titleTextDan) || '';
          annoElement.getElementsByClassName('titleTextDan')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('titleTextGer')[0].value = (annoData.val() && annoData.val().titleTextGer) || '';
          annoElement.getElementsByClassName('titleTextGer')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('bodyTextSwe')[0].value = (annoData.val() && annoData.val().bodyTextSwe) || '';
          annoElement.getElementsByClassName('bodyTextSwe')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('bodyTextEng')[0].value = (annoData.val() && annoData.val().bodyTextEng) || '';
          annoElement.getElementsByClassName('bodyTextEng')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('bodyTextDan')[0].value = (annoData.val() && annoData.val().bodyTextDan) || '';
          annoElement.getElementsByClassName('bodyTextDan')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('bodyTextGer')[0].value = (annoData.val() && annoData.val().bodyTextGer) || '';
          annoElement.getElementsByClassName('bodyTextGer')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('extraImage1Tag')[0].value = (annoData.val() && annoData.val().extraImage1Tag) || '';
          annoElement.getElementsByClassName('extraImage1Tag')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('ccbyText1')[0].value = (annoData.val() && annoData.val().ccbyText1) || '';
          annoElement.getElementsByClassName('ccbyText1')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('extraImage2Tag')[0].value = (annoData.val() && annoData.val().extraImage2Tag) || '';
          annoElement.getElementsByClassName('extraImage2Tag')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('ccbyText2')[0].value = (annoData.val() && annoData.val().ccbyText2) || '';
          annoElement.getElementsByClassName('ccbyText2')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('extraImage3Tag')[0].value = (annoData.val() && annoData.val().extraImage3Tag) || '';
          annoElement.getElementsByClassName('extraImage3Tag')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
          annoElement.getElementsByClassName('ccbyText3')[0].value = (annoData.val() && annoData.val().ccbyText3) || '';
          annoElement.getElementsByClassName('ccbyText3')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
        });
        roomRef.on('child_removed', function (annoData) {
          var containerElement = annotationsSection.getElementsByClassName('annos-container')[0];
          var anno = containerElement.getElementsByClassName('anno-' + roomKey + '-' + annoData.key)[0];
          anno.parentElement.removeChild(anno);
        });

        listeningFirebaseRefs.push(roomRef);
      });
    }
  });

  // fetchAnnotations(sweAnnotationRef, swedishAnnotationsSection, sweAnnotationPath);
  // fetchAnnotations(engAnnotationRef, englishAnnotationsSection, engAnnotationPath);
  // fetchAnnotations(danAnnotationRef, danishAnnotationsSection, danAnnotationPath);
  // fetchAnnotations(gerAnnotationRef, germanAnnotationsSection, gerAnnotationPath);

  // listeningFirebaseRefs.push(sweAnnotationRef);
  // listeningFirebaseRefs.push(engAnnotationRef);
  // listeningFirebaseRefs.push(danAnnotationRef);
  // listeningFirebaseRefs.push(gerAnnotationRef);
  listeningFirebaseRefs.push(annotationRef);
}

function startDatabaseQueriesImageTagLinks() {
  var imageTagLinksRef = firebase.database().ref('ImageTagLinks');

  imageTagLinksRef.on('child_added', function (data) {
    var imageTagId = data.key;
    var link = data.val() || '';
    var containerElement = imageTagLinksSection.getElementsByClassName('imagetag-links-container')[0];
    containerElement.appendChild(
      createImageTagLinkElement(imageTagId, link)
    );
  });
  imageTagLinksRef.on('child_changed', function (data) {
    var containerElement = imageTagLinksSection.getElementsByClassName('imagetag-links-container')[0];
    var imageTagLinkElement = containerElement.getElementsByClassName('imagetag-link-' + data.key)[0];
    imageTagLinkElement.getElementsByClassName('link-input')[0].value = data.val() || '';
    imageTagLinkElement.getElementsByClassName('link-input')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  });
  imageTagLinksRef.on('child_removed', function (data) {
    var containerElement = imageTagLinksSection.getElementsByClassName('imagetag-links-container')[0];
    var imageTagLink = containerElement.getElementsByClassName('imagetag-link-' + data.key)[0];
    imageTagLink.parentElement.removeChild(imageTagLink);
  });

  listeningFirebaseRefs.push(imageTagLinksRef);
}

function startDatabaseQueriesGuides() {
  var guidesRef = firebase.database().ref('GuideData');

  guidesRef.on('child_added', function (data) {
    var guideId = data.key;
    var GuideNameswedish = (data.val() && data.val().GuideName && data.val().GuideName.swedish) || '';
    var GuideNameenglish = (data.val() && data.val().GuideName && data.val().GuideName.english) || '';
    var GuideNamedanish = (data.val() && data.val().GuideName && data.val().GuideName.danish) || '';
    var GuideNamegerman = (data.val() && data.val().GuideName && data.val().GuideName.german) || '';

    var GuideTextTitleswedish = (data.val() && data.val().GuideTextTitle && data.val().GuideTextTitle.swedish) || '';
    var GuideTextTitleenglish = (data.val() && data.val().GuideTextTitle && data.val().GuideTextTitle.english) || '';
    var GuideTextTitledanish = (data.val() && data.val().GuideTextTitle && data.val().GuideTextTitle.danish) || '';
    var GuideTextTitlegerman = (data.val() && data.val().GuideTextTitle && data.val().GuideTextTitle.german) || '';

    var GuideBodyTextswedish = (data.val() && data.val().GuideBodyText && data.val().GuideBodyText.swedish) || '';
    var GuideBodyTextenglish = (data.val() && data.val().GuideBodyText && data.val().GuideBodyText.english) || '';
    var GuideBodyTextdanish = (data.val() && data.val().GuideBodyText && data.val().GuideBodyText.danish) || '';
    var GuideBodyTextgerman = (data.val() && data.val().GuideBodyText && data.val().GuideBodyText.german) || '';

    var SwedishAudioFile = (data.val() && data.val().SwedishAudioFile) || '';
    var EnglishAudioFile = (data.val() && data.val().EnglishAudioFile) || '';
    var DanishAudioFile = (data.val() && data.val().DanishAudioFile) || '';
    var GermanAudioFile = (data.val() && data.val().GermanAudioFile) || '';

    var SwedishSignVideoFile = (data.val() && data.val().SwedishSignVideoFile) || '';

    var containerElement = guidesSection.getElementsByClassName('guides-container')[0];
    containerElement.appendChild(
      createGuideElement(guideId, GuideNameswedish, GuideNameenglish, GuideNamedanish, GuideNamegerman, GuideTextTitleswedish, GuideTextTitleenglish, GuideTextTitledanish, GuideTextTitlegerman, GuideBodyTextswedish, GuideBodyTextenglish, GuideBodyTextdanish, GuideBodyTextgerman, SwedishAudioFile, EnglishAudioFile, DanishAudioFile, GermanAudioFile, SwedishSignVideoFile)
    );
  });
  guidesRef.on('child_changed', function (data) {
    var containerElement = guidesSection.getElementsByClassName('guides-container')[0];
    var guideElement = containerElement.getElementsByClassName('guide-' + data.key)[0];

    guideElement.getElementsByClassName('GuideNameswedish')[0].value = (data.val() && data.val().GuideName && data.val().GuideName.swedish) || '';
    guideElement.getElementsByClassName('GuideNameswedish')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GuideNameenglish')[0].value = (data.val() && data.val().GuideName && data.val().GuideName.english) || '';
    guideElement.getElementsByClassName('GuideNameenglish')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GuideNamedanish')[0].value = (data.val() && data.val().GuideName && data.val().GuideName.danish) || '';
    guideElement.getElementsByClassName('GuideNamedanish')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GuideNamegerman')[0].value = (data.val() && data.val().GuideName && data.val().GuideName.german) || '';
    guideElement.getElementsByClassName('GuideNamegerman')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();

    guideElement.getElementsByClassName('GuideTextTitleswedish')[0].value = (data.val() && data.val().GuideTextTitle && data.val().GuideTextTitle.swedish) || '';
    guideElement.getElementsByClassName('GuideTextTitleswedish')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GuideTextTitleenglish')[0].value = (data.val() && data.val().GuideTextTitle && data.val().GuideTextTitle.english) || '';
    guideElement.getElementsByClassName('GuideTextTitleenglish')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GuideTextTitledanish')[0].value = (data.val() && data.val().GuideTextTitle && data.val().GuideTextTitle.danish) || '';
    guideElement.getElementsByClassName('GuideTextTitledanish')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GuideTextTitlegerman')[0].value = (data.val() && data.val().GuideTextTitle && data.val().GuideTextTitle.german) || '';
    guideElement.getElementsByClassName('GuideTextTitlegerman')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();

    guideElement.getElementsByClassName('GuideBodyTextswedish')[0].value = (data.val() && data.val().GuideBodyText && data.val().GuideBodyText.swedish) || '';
    guideElement.getElementsByClassName('GuideBodyTextswedish')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GuideBodyTextenglish')[0].value = (data.val() && data.val().GuideBodyText && data.val().GuideBodyText.english) || '';
    guideElement.getElementsByClassName('GuideBodyTextenglish')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GuideBodyTextdanish')[0].value = (data.val() && data.val().GuideBodyText && data.val().GuideBodyText.danish) || '';
    guideElement.getElementsByClassName('GuideBodyTextdanish')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GuideBodyTextgerman')[0].value = (data.val() && data.val().GuideBodyText && data.val().GuideBodyText.german) || '';
    guideElement.getElementsByClassName('GuideBodyTextgerman')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();

    guideElement.getElementsByClassName('SwedishAudioFile')[0].value = (data.val() && data.val().SwedishAudioFile) || '';
    guideElement.getElementsByClassName('SwedishAudioFile')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('EnglishAudioFile')[0].value = (data.val() && data.val().EnglishAudioFile) || '';
    guideElement.getElementsByClassName('EnglishAudioFile')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('DanishAudioFile')[0].value = (data.val() && data.val().DanishAudioFile) || '';
    guideElement.getElementsByClassName('DanishAudioFile')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    guideElement.getElementsByClassName('GermanAudioFile')[0].value = (data.val() && data.val().GermanAudioFile) || '';
    guideElement.getElementsByClassName('GermanAudioFile')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();

    guideElement.getElementsByClassName('SwedishSignVideoFile')[0].value = (data.val() && data.val().SwedishSignVideoFile) || '';
    guideElement.getElementsByClassName('SwedishSignVideoFile')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  });
  guidesRef.on('child_removed', function (data) {
    var containerElement = guidesSection.getElementsByClassName('guides-container')[0];
    var guide = containerElement.getElementsByClassName('guide-' + data.key)[0];
    guide.parentElement.removeChild(guide);
  });

  listeningFirebaseRefs.push(guidesRef);
}

function startDatabaseQueriesGeneralTexts() {
  var containerElement = generalTextsSection.getElementsByClassName('texts-container')[0];
  containerElement.appendChild(
    createGeneralTextEditElement()
  );

  var generalTextsRef = firebase.database().ref('General-Texts');

  generalTextsRef.on('child_added', function (data) {
    var textId = data.key;
    var swedish = (data.val() && data.val().swedish) || '';
    var english = (data.val() && data.val().english) || '';
    var danish = (data.val() && data.val().danish) || '';
    var german = (data.val() && data.val().german) || '';
    var containerElement = generalTextsSection.getElementsByClassName('texts-container')[0];
    containerElement.appendChild(
      createGeneralTextElement(textId, swedish, english, danish, german)
    );
  });
  generalTextsRef.on('child_changed', function (data) {
    var containerElement = generalTextsSection.getElementsByClassName('texts-container')[0];
    var generalTextElement = containerElement.getElementsByClassName('general-text-' + data.key)[0];
    generalTextElement.getElementsByClassName('swedish-generalText')[0].value = (data.val() && data.val().swedish) || '';
    generalTextElement.getElementsByClassName('swedish-generalText')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    generalTextElement.getElementsByClassName('enlish-generalText')[0].value = (data.val() && data.val().english) || '';
    generalTextElement.getElementsByClassName('enlish-generalText')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    generalTextElement.getElementsByClassName('danish-generalText')[0].value = (data.val() && data.val().danish) || '';
    generalTextElement.getElementsByClassName('danish-generalText')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
    generalTextElement.getElementsByClassName('german-generalText')[0].value = (data.val() && data.val().german) || '';
    generalTextElement.getElementsByClassName('german-generalText')[0].parentElement.MaterialTextfield.boundUpdateClassesHandler();
  });
  generalTextsRef.on('child_removed', function (data) {
    var containerElement = generalTextsSection.getElementsByClassName('texts-container')[0];
    var generalText = containerElement.getElementsByClassName('general-text-' + data.key)[0];
    generalText.parentElement.removeChild(generalText);
  });

  listeningFirebaseRefs.push(generalTextsRef);
}

/**
 * Writes the user's data to the database.
 */
function writeUserData(userId, name, email, imageUrl) {
  firebase.database().ref('users/' + userId).set({
    username: name,
    email: email,
    profile_picture: imageUrl
  });
}

/**
 * Cleanups the UI and removes all Firebase listeners.
 */
function cleanupUi() {
  // Remove all previously displayed data.
  annotationsSection.getElementsByClassName('annos-container')[0].innerHTML = '';
  //annotationRadios.innerHTML = '';
  // swedishAnnotationsSection.getElementsByClassName('annos-container')[0].innerHTML = '';
  // englishAnnotationsSection.getElementsByClassName('annos-container')[0].innerHTML = '';
  // danishAnnotationsSection.getElementsByClassName('annos-container')[0].innerHTML = '';
  // germanAnnotationsSection.getElementsByClassName('annos-container')[0].innerHTML = '';

  imageTagLinksSection.getElementsByClassName('imagetag-links-container')[0].innerHTML = '';
  guidesSection.getElementsByClassName('guides-container')[0].innerHTML = '';
  generalTextsSection.getElementsByClassName('texts-container')[0].innerHTML = '';

  // Stop all currently listening Firebase listeners.
  listeningFirebaseRefs.forEach(function (ref) {
    ref.off();
  });
  listeningFirebaseRefs = [];
}

var isDev = false;
/**
 * Check if dev
 */
function checkIfDev(uid) {
  const DURef = firebase.database().ref('devusers');
  DURef.child(uid).get().then((snapshot) => {
    if (snapshot.exists()) {
      //console.log(snapshot.val());
      imageTagLinksButton.style.display = 'block';
      isDev = true;
    } else {
      //console.log("No data available");
      imageTagLinksButton.style.display = 'none';
      isDev = false;
    }
  }).catch((error) => {
    console.error(error);
  });
}


/**
 * The ID of the currently signed-in User. We keep track of this to detect Auth state change events that are just
 * programmatic token refresh but not a User status change.
 */
var currentUID;

/**
 * Triggers every time there is a change in the Firebase auth state (i.e. user signed-in or user signed out).
 */
function onAuthStateChanged(user) {
  // We ignore token refresh events.
  if (user && currentUID === user.uid) {
    return;
  }

  cleanupUi();
  if (user) {
    currentUID = user.uid;
    splashPage.style.display = 'none';
    writeUserData(user.uid, user.displayName, user.email, user.photoURL);

    topUserName.innerText = user.displayName || 'Anonymous';
    topAvatarPicture.style.backgroundImage = 'url("' +
      (user.photoURL || './silhouette.jpg') + '")';
    checkIfDev(currentUID);

    startDatabaseQueries();
  } else {
    // Set currentUID to null.
    currentUID = null;
    // Display the splash page where you can sign-in.
    splashPage.style.display = '';
  }
}

/**
 * Displays the given section element and changes styling of the given button.
 */
function showSection(sectionElement, buttonElement) {
  annotationsSection.style.display = 'none';
  // swedishAnnotationsSection.style.display = 'none';
  // englishAnnotationsSection.style.display = 'none';
  // danishAnnotationsSection.style.display = 'none';
  // germanAnnotationsSection.style.display = 'none';
  imageTagLinksSection.style.display = 'none';
  guidesSection.style.display = 'none';
  generalTextsSection.style.display = 'none';

  annotationsButton.classList.remove('is-active');
  // swedishAnnotationsButton.classList.remove('is-active');
  // englishAnnotationsButton.classList.remove('is-active');
  // danishAnnotationsButton.classList.remove('is-active');
  // germanAnnotationsButton.classList.remove('is-active');
  imageTagLinksButton.classList.remove('is-active');
  guidesButton.classList.remove('is-active');
  generalTextsButton.classList.remove('is-active');

  if (sectionElement) {
    sectionElement.style.display = 'block';
  }
  if (buttonElement) {
    buttonElement.classList.add('is-active');
  }
}

// Bindings on load.
window.addEventListener('load', function () {
  // Bind Sign in button.
  signInButton.addEventListener('click', function () {
    var provider = new firebase.auth.GoogleAuthProvider();
    firebase.auth().signInWithPopup(provider);
  });

  signInButtonMicrosoft.addEventListener('click', function () {
    var provider = new firebase.auth.OAuthProvider('microsoft.com');
    firebase.auth().signInWithPopup(provider);
  });

  // Bind Sign out button.
  signOutButton.addEventListener('click', function () {
    firebase.auth().signOut();
  });

  // Listen for auth state changes
  firebase.auth().onAuthStateChanged(onAuthStateChanged);

  // Bind menu buttons.
  annotationsButton.onclick = function () {
    showSection(annotationsSection, annotationsButton);
  };
  // swedishAnnotationsButton.onclick = function () {
  //   showSection(swedishAnnotationsSection, swedishAnnotationsButton);
  // };
  // englishAnnotationsButton.onclick = function () {
  //   showSection(englishAnnotationsSection, englishAnnotationsButton);
  // };
  // danishAnnotationsButton.onclick = function () {
  //   showSection(danishAnnotationsSection, danishAnnotationsButton);
  // };
  // germanAnnotationsButton.onclick = function () {
  //   showSection(germanAnnotationsSection, germanAnnotationsButton);
  // };
  imageTagLinksButton.onclick = function () {
    showSection(imageTagLinksSection, imageTagLinksButton);
  };
  guidesButton.onclick = function () {
    showSection(guidesSection, guidesButton);
  };
  generalTextsButton.onclick = function () {
    showSection(generalTextsSection, generalTextsButton);
  };
  annotationsButton.onclick();
}, false);
